

/* Autor:           Dipl.-Inf., Dipl.-Ing. (FH) Michael Wilhelm
   Firma:           HS Harz, FB AI
   EMail:           mwilhelm@hs-harz.de
   Projekt:         JExplorer
   Version:         0.8
   Ersterstellung:  10.10.2006
   Letzte nderung: 25.11.2006
*/

// Speichert die Information einer Datei bzw. eines Verzeichnisses
// Ist im Baum UND in der Tabelle zu finden


import java.io.*;

// implements  Comparable frs Sortieren, Collection.sort
public class CFile  implements  Comparable {

    // Statische variablen zum Sortieren, alle DREI !!!!
    // Wenn sorttyp == sorttyp_alt, dann wird die Richtung umgekehrt
    private static int sorttyp=0;
    private static int sorttyp_alt=0;
    private static int vorz=+1;

    // Normale Attribute
    public String Name;
    public String Ext;
    public long length;
    public long date;
    
    public String fullPath;

    
    // muss statisch sein
    public static void setSortTyp(int sorttyp_neu) {
     if (sorttyp == sorttyp_neu) {
        sorttyp = sorttyp_neu;
        vorz=-vorz;
     }
     else {
         sorttyp_alt = sorttyp;
         sorttyp = sorttyp_neu;
         vorz=+1;
     }        
    }
    
    public CFile(File file) {
        Name = file.getName();
        // Abspalten der Dateierweiterung
        int pos = Name.lastIndexOf(".");
        if ( pos >=0)
            Ext = Name.substring(pos+1);
        else
            Ext="";
        length = file.length();
        date = file.lastModified();
        
        fullPath = file.getAbsolutePath();
    }


    // wird von Collection.sort()  aufgerufen
   public int compareTo(Object obj) {
     long l1,l2;
     CFile myObj = (CFile) obj;
     System.out.println("compare: "+Name+"    "+myObj.Name );
     int result=0;
     switch (sorttyp) {
      case 1: result=Name.compareToIgnoreCase(myObj.Name );
              break;  
      case 2: result=Ext.compareToIgnoreCase(myObj.Ext );
              break;
      case 3: l1 = length;
              l2 = myObj.length;
              if (l1  < l2 ) 
                 result= -1;
               else {
                 if (l1 > l2 )
                   result=1;
                 else
                   result=0;
               }
              break;
      case 4: l1 = date;
              l2 = myObj.date;
              if (l1  < l2 ) 
                 result=-1;
               else {
                 if (l1 > l2 )
                   result=1;
                 else
                   result=0;
               }
               break;
      default: result=0;
     }
     return result*vorz;  // Reihenfolge umdrehen !
   }

}
