

/* Autor:           Dipl.-Inf., Dipl.-Ing. (FH) Michael Wilhelm
   Firma:           HS Harz, FB AI
   EMail:           mwilhelm@hs-harz.de
   Projekt:         JExplorer
   Version:         0.8
   Ersterstellung:  10.10.2006
   Letzte nderung: 25.11.2006
*/


// Dialogfenster, um eine Datei umzubenennen

import java.awt.*;
import javax.swing.*;

import java.awt.event.*;



public class JDRenameFile extends JDialog {
  JLabel labelPfad1 = new JLabel("Pfad");
  JLabel labelPfad2 = new JLabel("C:\\");
  
  JLabel labelOld = new JLabel("Alter Name");
  JTextField TOldName = new JTextField();

  JLabel labelNew = new JLabel("Neuer Name");
  JTextField TNewName = new JTextField();

  JButton BnOk = new JButton("Ok");
  JButton BnESC = new JButton("Abbruch");
  
  private String _sFileName;
  private String _sNewFileName;
  
  boolean _bResult=false;
    
    /** Creates a new instance of JFRenameFile */
    public JDRenameFile(Frame parent, String sFileName) {
        super(parent);
        super.setModal(true);
        _sFileName = sFileName;
        setGUI();
        CBasis.centerScreen(this,null);
        setVisible(true);
        TNewName.requestFocus();  // Focus setzen
    }
    
    private void setGUI() {
        JPanel panelBn = new JPanel();

        setSize(500, 240);
        setTitle("Datei umbenennen");
        this.getContentPane().setLayout( new GridBagLayout() );

        labelPfad1.setFont( new Font("Arial", Font.BOLD,18)  );        
        labelPfad2.setFont( new Font("Arial", Font.BOLD,18)  );        
        
        labelOld.setFont( new Font("Arial", Font.BOLD,18)  );        
        TOldName.setFont( new Font("Arial", Font.BOLD,18)  );        
        labelNew.setFont( new Font("Arial", Font.BOLD,18)  );        
        TNewName.setFont( new Font("Arial", Font.BOLD,18)  );        
        
        BnOk.setFont( new Font("Arial", Font.BOLD,18)  );        
        BnESC.setFont( new Font("Arial", Font.BOLD,18)  );        
        
        TOldName.setText(_sFileName);
        TNewName.setText(_sFileName);


        this.getContentPane().add(labelPfad1, 
                new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
                ,GridBagConstraints.WEST, GridBagConstraints.NONE, 
                new Insets(10,20,0,0), 0, 6));

        this.getContentPane().add(labelPfad2,   
                new GridBagConstraints(1, 0, 3, 1, 1.0, 0.0
                ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, 
                new Insets(10,20,0,20), 22, 6));

        // ----------------

        this.getContentPane().add(labelOld, 
                new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0
                ,GridBagConstraints.WEST, GridBagConstraints.NONE, 
                new Insets(10,20,0,0), 0, 6));

        this.getContentPane().add(TOldName,   
                new GridBagConstraints(1, 1, 3, 1, 1.0, 0.0
                ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, 
                new Insets(10,20,0,20), 22, 6));
        

        // ----------------

        this.getContentPane().add(labelNew, 
                new GridBagConstraints(0, 2, 1, 1, 0.0, 0.0
                ,GridBagConstraints.WEST, GridBagConstraints.NONE, 
                new Insets(10,20,0,0), 0, 6));

        this.getContentPane().add(TNewName,   
                new GridBagConstraints(1, 2, 3, 1, 1.0, 0.0
                ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, 
                new Insets(10,20,0,20), 22, 6));

        
        panelBn.add(BnOk);
        panelBn.add(BnESC);


        this.getContentPane().add(panelBn,  
                new GridBagConstraints(1, 3, 2, 1, 1.0, 0.0
                ,GridBagConstraints.EAST, GridBagConstraints.HORIZONTAL, 
                new Insets(10,0,0,20), 0, 0));

        BnOk.addActionListener(new java.awt.event.ActionListener() {
          public void actionPerformed(ActionEvent e) {
            BnOk_Click();
          }
        });
        
        BnESC.addActionListener(new java.awt.event.ActionListener() {
          public void actionPerformed(ActionEvent e) {
            BnESC_Click();
          }
        });
    }
    
    private void BnESC_Click() {
        _bResult=false;
        dispose();
    }
    
    // liefert den Wert, on Ok oder Abbruch gedrckt wurde
    public boolean getResult() {
        return _bResult;
    }

    // wenn ok gedrckt, dann holt man sich den Namen
    public String getNewName() {
        return _sNewFileName;
    }
    
    // jetzt noch mit kleiner Plausibilittsprfung
    private void BnOk_Click() {
        _bResult=true;
        // lschen der Leerstellen an den Rndern
        _sNewFileName = TNewName.getText().trim();
        if ( _sNewFileName.length() == 0) {
            CBasis.Error("Fehler","Bitte geben Sie einen neuen Namen ein");
            TNewName.requestFocus(); // setzt Focus
            return;
        }
        dispose();
    }
    
}
